/*
  machine.h
  Copyright (C) 2008-2009 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of qgmap.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __MACHINE_H__
#define __MACHINE_H__

#include <qsize.h>

typedef enum MachineType {
	SL_C,
	SL_A300,
	PC,
} MachineType;

typedef enum Resolution {
	VGA,
	QVGA,
} Resolution;

class Machine
{
  public:
	Machine(void);
	~Machine();

	MachineType type();
	Resolution resolution();
	void setGlobalDefaults();
	QSize screensize();
	int screenShortLen();
	int screenLongLen();
	QString picsPath(QString file);

  protected:
	MachineType type_;
	Resolution res_;
};

int check_machine_type(void);

#endif /* __MACHINE_H__ */
