/*
  main.cpp
  Copyright (C) 2008-2009 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of qgmap.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>

#ifdef QWS
#include <qpe/qpeapplication.h>
#else
#include <qapplication.h>
#endif
#include "mainwindow.h"

#include "qgconf.h"

#include "poi_db.h"
#include "poi_icon.h"
#include "machine.h"
#include <qcstring.h>
#include <qfile.h>

#include <pthread.h>


#include <qfile.h>
#include <qfileinfo.h>

pthread_mutex_t g_lock = PTHREAD_MUTEX_INITIALIZER;

QApplication *pApp;
MainWindow *pMainWindow;

QString g_db_poi;
Machine g_machine;

int register_poi(void)
{
	PoiDb db(g_db_poi);
	QByteArray ba = db.getPoiIcon(0);

	if (db.getPoiIcon(PoiDb::PRESET_OFFSET).isNull()) {
		QImage icons(ICONS_FILE);
//		printf("icons.isNull() = %d\n", icons.isNull());
		if (icons.isNull())
			return 0;

		int num = icons.width() / 16;
//		printf("size = %dx%d\n", icons.width(), icons.height());

		db.beginTransaction();
		for (int i = 0; i < num; i++) {
			QByteArray *data = PoiIcon::convertPNGdata(
				icons.copy(i * 16, 0, 16, 16));
			db.addIcon(*data, PoiDb::PRESET_OFFSET + i);
			delete data;
		}
		db.commitTransaction();
	}

#if 0
	printf("count = %d\n", db.countItem(QString::fromUtf8("俣")));

	PoiDbItem *item = db.searchItem(QString::fromUtf8("俣"));
	if (!item)
		return 0;

	printf("**result**\n");
	while (item->next()) {
		printf("%d %d %d %d %s %s\n",
			   item->getId(), item->getFileId(),
			   item->getX(), item->getY(),
			   (const char *)item->getName().utf8(),
			   (const char *)item->getInfo().utf8());
	}
#endif

	return 0;
}

int main(int argc, char **argv)
{
	g_machine.setGlobalDefaults();

#ifdef QWS
	QPEApplication app(argc, argv);
	pMainWindow = new MainWindow(NULL, "MainWindow");

	app.showMainWidget(pMainWindow);
#else
	QApplication app(argc, argv);
	pMainWindow = new MainWindow(NULL, "MainWindow");

	app.setMainWidget(pMainWindow);
	pMainWindow->show();
#endif

	pApp = &app;

	register_poi();

	int ret = app.exec();

	delete pMainWindow;
	return ret;
}
