/*
  map_gmap.h
  Copyright (C) 2008-2009 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of qgmap.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __MAP_GMAP_H__
#define __MAP_GMAP_H__

#include <qobject.h>
#include <qcache.h>
#include <qimage.h>
#include "pos.h"
#include "map_item.h"
#include "mappath.h"

class MapItemGMap : public MapItem
{
	Q_OBJECT;
  public:
	MapItemGMap(Map *parent, int cache_size);
	~MapItemGMap();

	bool drawItem(QImage &scr, const Pos &pos);

  private:
	void setGamma(double gamma);
	void gammaCorrection(QImage *img);
	QImage *zoom(QImage *img, int z, Pos const &pos);

	int gamma_table[256];
	MapPath mappath;

	int max_down;

	QImage noimage;

	QCache<QImage> img_cache;

  public slots:
	void setConfig(const QString &key, const QString &value);
};

#endif // __MAP_H__
